;; pgshell.el - Proof General for shell scripts.
;;
;; David Aspinall.  pgshell.el,v 11.0 2010/10/10 22:57:10 da Exp
;;
;; This instance of PG is handy just for using script management to
;; cut-and-paste into a buffer running an ordinary shell of some kind.
;;
;; I'm providing this so that tool demonstrators may use it instead of
;; tediously doing cut-and-paste of commands from a file.  No history
;; management, and nothing to do with theorem proving really!
;;
;; To use this instance of PG, visit a file with the ".pgsh" extension.
;;
;; Feedback welcome.


(require 'proof-easy-config)
(require 'proof-syntax)

(proof-easy-config 'veriml "VeriML"

 proof-prog-name		     "/home/antonis/work/flint/papers/veriml/veriml-hol/veriml"  ;; or your program
 proof-terminal-string                 ">>;;"        ;; end of commands
 proof-script-comment-start          "(*"	;; comments
 proof-script-comment-end            "*)"	;; comments
 proof-shell-annotated-prompt-regexp "# " ;; matches prompts

 proof-shell-strip-crs-from-input nil
 ;;proof-shell-end-goals-regexp	 "- : unit = ()"
 proof-shell-interrupt-regexp        "^.*Exception:\\|^.*failure\\|^.*Error:"

 ;; next setting is just to prevent warning
 proof-save-command-regexp	proof-no-regexp
 )

(provide 'veriml)
